@echo OFF
REM
REM Copyright IBM Corp.(c) 2005
REM 		mjuarez@us.ibm.com
REM Update.cmd
REM 	Will read target update files from update.files 
REM 	Will copy files from UPDATES directory
REM 	Will backup files to BASEDIR/backup.DATE directory
REM 

SETLOCAL
set BASEDIR=%~1

REM Set the date for backup and logfile
for /F "usebackq" %%d IN (`date /T`) DO @SET BACKUP=%BASEDIR%\UPDATE_Backup.%%d&@SET LOGFILE=%BASEDIR%\UPDATE_%%d.log

if "%BASEDIR%"=="" goto USAGE

IF NOT exist README.txt GOTO CONTINUE
echo ------- README FILE -----------
echo.
more README.txt
echo.
echo Press Ctrl-C to Cancel or
Pause

:CONTINUE
if not exist .\UPDATES goto UPDATES_NOT_FOUND
if not exist .\UPDATE.config goto UPDATES_NOT_FOUND
if not exist "%BASEDIR%" goto BASEDIR_ERROR
if not exist "%BASEDIR%\config\tmtpversion.properties" goto TMTP_NOT_FOUND

echo ----- START ------ >> "%LOGFILE%"
date /T >> "%LOGFILE%"
time /T >> "%LOGFILE%"

IF NOT EXIST "%BACKUP%" mkdir "%BACKUP%"

IF EXIST UPDATE.config\CUSTOMPreUpdate.cmd @call UPDATE.config\CUSTOMPreUpdate.cmd 2>&1 >> "%LOGFILE%"

REM Loop to handle multiple sets of files
for %%l in (UPDATE.config\*.files) DO @call UPDATE.config\UpdateSet.cmd "%%l" "%BACKUP%" "%BASEDIR%" 
@echo OFF

IF EXIST UPDATE.config\CUSTOMPostUpdate.cmd @call UPDATE.config\CUSTOMPostUpdate.cmd 2>&1 >> "%LOGFILE%"

echo Update complete !
echo Backup location: %BACKUP%
goto FIN

:USAGE
echo USAGE: UPDATE ^<BASEDIR^>
echo Example: UPDATE "C:\Program Files\ibm\tivoli\MA"
echo          UPDATE "C:\Program Files\ibm\tivoli\MS"
GOTO FIN

:UPDATES_NOT_FOUND
echo ERROR. Command must be executed from the parent directory of the UPDATES directory
goto FIN

:BASEDIR_ERROR
echo ERROR. %BASEDIR% can't be found.
goto FIN

:TMTP_NOT_FOUND
echo ERROR. TMTP does not seem to be found in %BASEDIR%
echo %BASEDIR%\config\tmtpversion.properties must be present.
goto :FIN

:FIN
echo ----- End ------ >> "%LOGFILE%"
date /T >> "%LOGFILE%"
time /T >> "%LOGFILE%"
ENDLOCAL

